package SDL::Build::Freebsd;

use base 'SDL::Build';

sub fetch_includes
{
	return (
		'/usr/include'             => '/usr/lib',
		'/usr/include/SDL'         => '/usr/lib',
		'/usr/local/include'       => '/usr/local/lib',
		'/usr/local/include/SDL'   => '/usr/local/lib',
		'/usr/local/include/SDL11' => '/usr/local/lib',
		'/usr/X11R6/include'       => '/usr/X11R6/lib',
	);
}

sub build_links
{
	my $self  = shift;
	my $links = $self->SUPER::build_links();

	for my $subsystem ( values %$links )
	{
		push @{ $subsystem{libs} }, '-pthread';
	}

	return $links;
}

1;
