#	Font.pm
#
#	a SDL perl extension for SFont support
#
#	Copyright (C) David J. Goehrig 2000,2002
#

package SDL::Font;

use strict;

use SDL;
use SDL::Surface;

use vars qw(@ISA $CurrentFont);

@ISA = qw(SDL::Surface);

sub new
{
	my ($class, $fontname) = @_;

	bless
	{
		-fontname => $fontname,
		-surface  => SDL::NewFont( $fontname ),
	}, $class;
}

sub DESTROY
{
	my $self = shift;
	SDL::FreeSurface( $self->{-surface} );
}

sub use
{
	my $self     = shift;
#	$CurrentFont = $self;

	SDL::UseFont( $self->{-surface} ) if $self->isa('SDL::Font');
}

1;

__END__;

=head1 NAME

SDL::Font - a SDL perl extension

=head1 SYNOPSIS

  $font = new Font "Font.png";
  $font->use();
	
=head1 DESCRIPTION



=head1 AUTHOR

David J. Goehrig

=head1 SEE ALSO

perl(1) SDL::Surface(3)

=cut
