#!/usr/bin/env perl
#

open XS, "< sdl_words.txt" or die "could not open sdl_words.txt\n";
open CPP, "| cpp `sdl-config --cflags` - > SDL.cx"
	or die "Could not pipe to cpp, $!\n";

print CPP <<HEADER;
#include <SDL.h>
#define TEXT_SOLID	1
#define TEXT_SHADED	2
#define TEXT_BLENDED	4
#define UTF8_SOLID	8
#define UTF8_SHADED	16	
#define UTF8_BLENDED	32
#define UNICODE_SOLID	64
#define UNICODE_SHADED	128
#define UNICODE_BLENDED	256

--cut--
HEADER

while (<XS>) {
	chomp();
	print CPP "#$_ $_\n";
	$words{$_} = 0;
}

close XS;
close CPP;

#
# ENUMS AREN'T CPPed we got to do this the hard way
#

open FP, "> sdl_const.c" or die "Could not write to sdl__const.c\n";

print FP <<HERE;
#include <SDL.h>
#include <SDL_image.h>
#include <SDL_mixer.h>
#include <SDL_ttf.h>
#include <SDL_net.h>
#include <SDL_events.h>
#include <smpeg/smpeg.h>
#define TEXT_SOLID	1
#define TEXT_SHADED	2
#define TEXT_BLENDED	4
#define UTF8_SOLID	8
#define UTF8_SHADED	16	
#define UTF8_BLENDED	32
#define UNICODE_SOLID	64
#define UNICODE_SHADED	128
#define UNICODE_BLENDED	256

int
main ( int argc, char **argv ) {

HERE

for ( grep { $words{$_} == 0 } keys %words ) { 
	print FP qq|printf( "$_\t%d\\n", $_ );\n|;
}

print FP <<HERE;
}
HERE

system("gcc `sdl-config --cflags --libs` -o sdl_const sdl_const.c");

open ENUMS, "./sdl_const |";
while (<ENUMS>)
{
	chomp;
	my ($name, $value) = split(/\t/, $_);
	$name =~ s/^SDL_//;
	$words{ $name } = $value;
}
close ENUMS;

for (keys %words) {
	print STDERR "Failed to find $_\n" unless $words{$_};	
}

open CONST, "> ../lib/SDL/Constants.pm";

print CONST <<HERE;
# SDL::Constants
#
# This is an automatically generated file, don't bother editing
#
# Copyright (C) 2003 David J. Goehrig <dave\@sdlperl.org>
#

package SDL::Constants;

use Exporter ();
use vars qw( \@ISA \@EXPORT );
\@ISA = 'Exporter';

HERE

my @export;
while (my ($constant, $value) = each %words)
{
	next unless defined $value;
	push @export, $constant;
	print CONST qq|sub $constant () { $value }\n|;
}

print CONST '@EXPORT = qw(', join( ' ', @export ), ');';

print CONST "\n1;\n";

END
{
	unless ($ENV{CONST_KEEP_FILES})
	{
		1 while unlink qw( SDL.cx sdl_const sdl_const.c );
	}
}
