#!/usr/bin/perl -w

# basic testing of SDL::Console

use Test::More tests => 3;

use strict;
use vars qw/@INC/;

use SDL::Config;
use SDL::Surface;

BEGIN
  {
  unshift @INC, ('../blib/lib');
  unshift @INC, ('../blib/arch');
  chdir 't' if -d 't';
  use_ok( 'SDL::Console' ); 
  }
  
can_ok ('SDL::Console', qw/
	new draw topmost AddCommand Event print alpha background
	list_commands resize position CommandDispatch
	/);

SKIP:
{
	skip( 'No SDL_console support compiled in', 1 )	
		unless SDL::Config->has( 'SDL_console' );

	my $console = 
		SDL::Console->new( -surface => SDL::Surface->new( -name => '', ) );
	isa_ok( $console, 'SDL::Console' );
}
