#!/usr/bin/perl -w

# basic testing of SDL::Mixer

use strict;
use vars qw/@INC/;

BEGIN
{
	use blib;
	chdir 't' if -d 't';
}

use SDL::Config;
use Test::More;

plan( skip_all => 'No SDL_mixer support compiled in' )
	unless SDL::Config->has( 'SDL_mixer' );

plan( tests => 4 );

use_ok( 'SDL::Mixer' ); 
  
can_ok ('SDL::Mixer', qw/
	new
	query_spec
	reserve_channels
	allocate_channels
	group_channel
	group_channels
	group_available
	group_count
	group_oldest
	group_newer
	play_channel
	play_music
	fade_in_channel
	fade_in_music
	channel_volume
	music_volume
	halt_channel
	halt_group
	halt_music
	channel_expire
	fade_out_channel
	fade_out_group
	fade_out_music
	fading_music
	fading_channel
	pause
	resume
	paused
	pause_music
	resume_music
	rewind_music
	music_paused
	playing
	playing_music
	/);

use SDL::Event;

# these are exported by default by Event, so main:: should know them:
can_ok ('main', qw/
	MIX_MAX_VOLUME
	MIX_DEFAULT_FREQUENCY
	MIX_DEFAULT_FORMAT
	MIX_DEFAULT_CHANNELS
	MIX_NO_FADING
	MIX_FADING_OUT
	MIX_FADING_IN
	AUDIO_U8
	AUDIO_S8
	AUDIO_U16
	AUDIO_S16
	AUDIO_U16MSB
	AUDIO_S16MSB
	/);

my $mixer = SDL::Mixer->new();
isa_ok($mixer, 'SDL::Mixer');
